#/*------------------------------------------------------------------------------
#--  This file is a part of the libuc, microcontroler library
#--  Copyright (C) 2011, Alexis Jeandet
#--
#--  This program is free software; you can redistribute it and/or modify
#--  it under the terms of the GNU General Public License as published by
#--  the Free Software Foundation; either version 3 of the License, or
#--  (at your option) any later version.
#--
#--  This program is distributed in the hope that it will be useful,
#--  but WITHOUT ANY WARRANTY; without even the implied warranty of
#--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#--  GNU General Public License for more details.
#--
#--  You should have received a copy of the GNU General Public License
#--  along with this program; if not, write to the Free Software
#--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#-------------------------------------------------------------------------------
#--                 Author : Alexis Jeandet
#--                   Mail : alexis.jeandet@gmail.com
#-------------------------------------------------------------------------------*/
LIBUC_LATEX = latex
LIBUC_DVIPDF = dvipdf
LIBUC_DVIPS = dvips
LIBUC_PS2PDF = ps2pdf
LIBUC_PDFLATEX = pdflatex

DVIFILES = $(LATEXSOURCES:.tex=.dvi)
PDFFILES = $(DVIFILES:.ps=.pdf)
PSFILES = $(DVIFILES:.dvi=.ps)
AUXDIR=aux
TOCDIR=toc
LOGDIR=log

all: 
	@echo "latex rules"
	
pdf: Makefile
	$(LIBUC_LATEX) $(LATEXSOURCES)
	$(LIBUC_DVIPS) $(DVIFILES)
	$(LIBUC_PS2PDF) $(PSFILES)
	$(LIBUC_LATEX) $(LATEXSOURCES)
	$(LIBUC_DVIPS) $(DVIFILES)
	$(LIBUC_PS2PDF) $(PSFILES)
	mkdir -p $(TOCDIR)
	mkdir -p $(AUXDIR)
	mkdir -p $(LOGDIR)
	mv *.toc $(TOCDIR)
	mv *.aux $(AUXDIR)
	mv *.log $(LOGDIR)
	

clean:
	rm -f *.toc *.aux *.log *.pdf *.dvi
	rm -f $(TOCDIR)/*
	rm -f $(AUXDIR)/*
	rm -f $(LOGDIR)/*
	
	
distclean: clean
	rm -f *.toc *.aux *.log *.pdf *.dvi
	rm -f Makefile

	
	
	
